// **********************************
// camera defect : blue channel noise 
// **********************************

// create a noised version of the output image
#declare t_bcn_noise=
texture{t_output_image}
texture{
  pigment{
    granite scale .1 turbulence 1 omega 1 lambda 10
    color_map{
      [0 rgb <1,0,0> transmit 1-bcn_amount]
      [0.5 rgbt 1]
      [1 rgb <0,1,0> transmit 1-bcn_amount]
    }
  }
  finish{emission 1 diffuse 0 brilliance 0}
}

// redeclare the output texture, using the input image to mix the 
// existing output and the noised texture, so that the noise affects
// more the mid tones, and not the brighter and darker tones
#declare t_output_image=
texture{ 
  pigment_pattern{
    input_image
  }
  cubic_wave
  texture_map{
    [0 t_output_image]
    [0.5 t_bcn_noise]
    [1 t_output_image]
  }
}
