// ************************************
// camera defect : chromatic aberration
// ************************************
// done just by displacing the color components before adding them
// back thogheter (don't ask about the 255 trickery: I found it just 
// helps to manage both low and high dynamic range images)

// traversal type
#if (aberration_type=1)
  #declare t_output_image=
  texture{
    pigment{
      average
      pigment_map{
        [
          function{f_p(x+aberration_amount,y+aberration_amount,z).x/255}   
          poly_wave pw
          color_map{[0 rgb 0][1 Red*3]}
        ]
        [
          function{f_p(x,y,z).y/255} 
          poly_wave pw
          color_map{[0 rgb 0][1 Green*3]}
        ]
        [
          function{f_p(x-aberration_amount,y-aberration_amount,z).z/255}  
          poly_wave pw
          color_map{[0 rgb 0][1 Blue*3]}
        ]
      }
    }
    finish{emission 255 diffuse 0 brilliance 0}
  }
#end

// longitudinal type
#if (aberration_type=2)
  #declare t_output_image=
  texture{
    pigment{
      average
        pigment_map{
          [
            function{f_p(x*(1-aberration_amount),y*(1-aberration_amount),z*(1-aberration_amount)).x/255}   
            poly_wave pw
            color_map{[0 rgb 0][1 Red*3]}
          ]
          [
            function{f_p(x,y,z).y/255} 
            poly_wave pw
            color_map{[0 rgb 0][1 Green*3]}
          ]
          [
            function{f_p(x*(1+aberration_amount),y*(1+aberration_amount),z*(1+aberration_amount)).z/255}
            poly_wave pw
            color_map{[0 rgb 0][1 Blue*3]}
          ]
        }
    }
    finish{emission 255 diffuse 0 brilliance 0}
  }
#end
