// I'm using 3.7 for HDR
#version 3.7;  

// global settings
global_settings{
 assumed_gamma 1.0
 max_trace_level 256 // some effects need very high values
}

// standard includes we will need
#include "colors.inc"        
#include "finish.inc"
#include "functions.inc"
#include "strings.inc"

// get some useful values
#declare width_ratio=image_width/image_height; 
#declare height_ratio=1;

// declare first the image_map alone for later reuse
#declare input_image_map=
pigment{
  image_map{
    #switch (image_type)
      #case (0)
        hdr
        #break
      #case (1)
        jpeg 
        #break
      #case (2)
        png
        #break
      #case (3)
        tga
        #break
    #end
    image_file gamma image_gamma
    once
    map_type 0
  }
}
// then apply distortion if enabled
#declare input_image=
pigment{
  input_image_map
  #if (optical_distortion)
    warp{black_hole <.5,.5,0>,1 strength distortion_amount}
  #end
  translate <-.5,-.5,0>
  // hide the borders a bit if using aberration
  scale 1+chromatic_aberration*aberration_amount*2 
}
// finally, create a pigment function of the input image 
#declare f_p=
function{
  pigment{input_image}
}

