// ********************************
// camera defect : dust on the lens 
// ********************************
// Puts objects in front of the camera, just a bit over the viewing plane,
// with random placement on the x-y plane to simulate an uncleaned lens.
// The objects are textured with a spherical gradient and colored with
// random dark colors, addind some turbulence to avoid perfectly spherical
// shapes.

#declare n_dust=dust_amount;
#declare i_dust=0;
#while (i_dust<n_dust)
  #declare dust_color=.3*rand(r_dust)+<.1*rand(r_dust),.1*rand(r_dust),.1*rand(r_dust)>;
  cylinder{-.01*z,.01*z,1
    pigment{
      spherical poly_wave .5+3.5*rand(r_dust) turbulence .33*rand(r_dust)
      color_map{
        [0 rgb dust_color transmit 1]
        [1 rgb dust_color transmit .1+.9*rand(r_dust)]
      }
      scale .5
    }
    finish{emission 1}
    rotate 360*rand(r_dust)*z
    scale (1/(image_width+image_height)/2)*(50+50*rand(r_dust))*dust_size
    translate <(-.5+rand(r_dust))*width_ratio,(-.5+rand(r_dust))*height_ratio,1>
  }
  #declare i_dust=i_dust+1;
#end
