// ************************************
// camera effect (defect?) : film grain
// ************************************

// create a grayscale noise texture to simulate film grain
#declare t_film_grain=
texture{
  pigment{
    bumps
    scale 1/(image_width+image_height) 
    color_map{
      [0.0 rgb 1]
      [0.5 rgb 1]
      [0.5 rgb 0]
      [1.0 rgb 0]
    }
  }
  finish{emission 1 diffuse 0 brilliance 0}
}
  
// average the noise above with the existing output texture
#declare t_output_image_with_grain=
texture{
  average
  texture_map{
    [1 t_output_image]
    [film_grain_amount t_film_grain]
  }
}

// redeclare the output texture, using the input image to mix the 
// existing output and the grained texture, so that the grain affects
// more the mid tones, and not the brighter and darker tones
#declare t_output_image=
texture{ 
  pigment_pattern{
    input_image
  }
  cubic_wave
  texture_map{
    [0 t_output_image]
    [film_grain_midtone t_output_image_with_grain]
    [1 t_output_image]
  }
}

