/*

  Jaime Vives Piqueres, Dec-2009
  --
  Image Mixer tool for the CDPP kit
  --
  Main use is to mix CDPP bokeh effect with a regular version of the image, using
  the focus map as guide, to be able to hide the parts of the circles of confusion
  wich overlap with on-focus objects.
  --
  Needs 3 images: the 2 input images to be mixed, and 1 grayscale map wich should 
  represent the focal depth (see examples)

*/

// I'm using MegaPOV for HDR, but you can use 3.7 beta, I suppose... I didn't test it
#version unofficial MegaPov 1.21; 

global_settings{
 // should correspond to the images gamma (either embbebed or assumed):
 assumed_gamma 2.2
}

// first input image
#declare t_input_image_1=
texture{
 pigment{
  image_map{hdr "atenea.hdr"}
 }
 finish{emission 1}
}

// second input image
#declare t_input_image_2=
texture{
 pigment{
  image_map{tga "cdpp.tga"}
 }
 finish{emission 1}
}

// mix them using the focus map
#declare t_output_image=
  texture{ 
    pigment_pattern{
      image_map{tga "atenea_fb-map.tga"} 
    }
    poly_wave 1
    texture_map{
      [0 t_input_image_1]
      [1 t_input_image_2]
    }
  }

// put the resulting texture on the screen plane
#include "screen.inc"
object{Screen_Plane(texture{t_output_image},1,<0,0,0>,<1,1,0>)
}
